package com.qmth.ops.api.controller.admin;

import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.api.security.AdminSession;
import com.qmth.ops.api.security.Permission;
import com.qmth.ops.biz.domain.App;
import com.qmth.ops.biz.domain.Env;
import com.qmth.ops.biz.domain.NginxConfig;
import com.qmth.ops.biz.service.AppService;
import com.qmth.ops.biz.service.EnvService;
import com.qmth.ops.biz.service.ModuleService;
import com.qmth.ops.biz.service.NginxConfigService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

@RestController
@RequestMapping(OpsApiConstants.ADMIN_URI_PREFIX + "/nginx")
public class NginxConfigController {

    @Resource
    private NginxConfigService nginxConfigService;

    @Resource
    private AppService appService;

    @Resource
    private ModuleService moduleService;

    @Resource
    private EnvService envService;

    @PostMapping("/find")
    public NginxConfig find(@RequestParam Long appId, @RequestParam(required = false) Long envId,
            @RequestParam(required = false) Long moduleId) {
        return nginxConfigService.find(appService.getById(appId), envId != null ? envService.getById(envId) : null,
                moduleId != null ? moduleService.getById(moduleId) : null);
    }

    @PostMapping("/update")
    public Object update(@RequestAttribute AdminSession adminSession, @RequestParam Long appId,
            @RequestParam(required = false) Long envId, @RequestParam(required = false) Long moduleId,
            @RequestParam String content) {
        App app = appService.getById(appId);
        Env env = null;
        if (envId != null) {
            env = envService.getById(envId);
            adminSession.hasPermission(Permission.NGINX_EDIT, env.getId());
        } else {
            adminSession.hasPermission(Permission.NGINX_BASELINE_EDIT, app.getId());
        }
        return nginxConfigService.update(app, env, moduleId != null ? moduleService.getById(moduleId) : null, content);
    }

}

