package com.qmth.ops.api.controller.admin;

import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.api.security.AdminSession;
import com.qmth.ops.api.security.Permission;
import com.qmth.ops.biz.domain.Wxapp;
import com.qmth.ops.biz.query.WxappQuery;
import com.qmth.ops.biz.service.WxappService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping(OpsApiConstants.ADMIN_URI_PREFIX + "/wxapp")
public class WxappController {

    @Resource
    private WxappService wxappService;

    @PostMapping("/query")
    public WxappQuery query(WxappQuery query) {
        return wxappService.findByQuery(query);
    }

    @PostMapping("/list")
    public List<Wxapp> list(WxappQuery query) {
        return wxappService.listByQuery(query);
    }

    @PostMapping("/insert")
    public Wxapp insert(@RequestAttribute AdminSession adminSession, Wxapp wxapp) {
        adminSession.hasPermission(Permission.WXAPP_INSERT);
        return wxappService.insert(wxapp);
    }

    @PostMapping("/update")
    public Wxapp update(@RequestAttribute AdminSession adminSession, Wxapp wxapp) {
        adminSession.hasPermission(Permission.WXAPP_EDIT);
        return wxappService.update(wxapp);
    }

}
