package com.qmth.ops.api.controller.ai;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.core.ai.model.AiConstants;
import com.qmth.boot.core.ai.model.doc.ParseDocTask;
import com.qmth.boot.core.ai.model.doc.ParseDocTaskResult;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.ops.api.security.AccessOrg;
import com.qmth.ops.biz.service.DocClientService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;

@RestController
@Aac(auth = true, signType = SignatureType.SECRET)
public class DocController {

    @Resource
    private DocClientService docClientService;

    @PostMapping(AiConstants.DOC_PARSE_TASK_PATH)
    public ParseDocTask parseDocTask(@RequestAttribute AccessOrg accessOrg, @RequestParam("file") MultipartFile file) throws Exception {
        return docClientService.parseDocTask(file.getBytes(), file.getOriginalFilename());
    }

    @PostMapping(AiConstants.DOC_PARSE_TASK_QUERY_PATH)
    public ParseDocTaskResult parseDocTaskQuery(@RequestAttribute AccessOrg accessOrg, @RequestParam("taskId") String taskId) throws Exception {
        return docClientService.parseDocTaskQuery(taskId);
    }

}
