package com.qmth.ops.api.dto;

import com.qmth.boot.core.solar.model.AppControl;
import com.qmth.ops.biz.domain.Deploy;
import com.qmth.ops.biz.domain.DeployMode;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import java.util.Set;

@Validated
public class DeployForm {

    public interface InsertGroup {

    }

    public interface UpdateGroup {

    }

    @NotNull(message = "id不能为空", groups = UpdateGroup.class)
    private Long id;

    @NotNull(message = "appId不能为空", groups = InsertGroup.class)
    private Long appId;

    @NotBlank(message = "name不能为空", groups = InsertGroup.class)
    private String name;

    @NotNull(message = "mode不能为空", groups = InsertGroup.class)
    private DeployMode mode;

    private AppControl control;

    private Set<String> ipAllow;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getAppId() {
        return appId;
    }

    public void setAppId(Long appId) {
        this.appId = appId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public DeployMode getMode() {
        return mode;
    }

    public void setMode(DeployMode mode) {
        this.mode = mode;
    }

    public AppControl getControl() {
        return control;
    }

    public void setControl(AppControl control) {
        this.control = control;
    }

    public Set<String> getIpAllow() {
        return ipAllow;
    }

    public void setIpAllow(Set<String> ipAllow) {
        this.ipAllow = ipAllow;
    }

    public Deploy build() {
        Deploy deploy = new Deploy();
        deploy.setId(id);
        deploy.setAppId(appId);
        deploy.setName(name);
        deploy.setMode(mode);
        deploy.setControl(control);
        deploy.setIpAllow(ipAllow);
        return deploy;
    }
}
