package com.qmth.ops.api.dto;

import com.qmth.ops.api.security.Permission;
import com.qmth.ops.biz.domain.UserPermission;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

@Validated
public class PermissionDTO {

    @NotNull
    private Permission permission;

    @NotBlank
    private String scope;

    public PermissionDTO() {

    }

    public PermissionDTO(UserPermission up) {
        this.permission = up.getPermission();
        this.scope = up.getScope();
    }

    public Permission getPermission() {
        return permission;
    }

    public void setPermission(Permission permission) {
        this.permission = permission;
    }

    public String getScope() {
        return scope;
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public UserPermission getUserPermission(Long userId) {
        UserPermission up = new UserPermission();
        up.setUserId(userId);
        up.setPermission(permission);
        up.setScope(scope);
        return up;
    }
}
