package com.qmth.ops.api.dto;

import com.qmth.ops.biz.domain.UserPermission;
import org.springframework.validation.annotation.Validated;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;
import java.util.stream.Collectors;

@Validated
public class UserPermissionDTO {

    @NotNull
    private Long userId;

    @NotNull
    @Size(min = 0)
    @Valid
    private List<PermissionDTO> permissions;

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public List<PermissionDTO> getPermissions() {
        return permissions;
    }

    public void setPermissions(List<PermissionDTO> permissions) {
        this.permissions = permissions;
    }

    public List<UserPermission> getUserPermissionList() {
        return permissions.stream().map(p -> p.getUserPermission(userId)).collect(Collectors.toList());
    }
}
