package com.qmth.ops.api.security;

import com.qmth.boot.core.ai.model.AiConstants;
import com.qmth.boot.core.security.annotation.AuthorizationComponent;
import com.qmth.boot.core.security.service.AuthorizationService;
import com.qmth.boot.tools.signature.SignatureType;
import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.biz.domain.Org;
import com.qmth.ops.biz.service.OrgService;

import javax.annotation.Resource;

@AuthorizationComponent(prefix = { AiConstants.API_PREFIX }, type = SignatureType.SECRET)
public class AiAuthorizationService implements AuthorizationService<AccessOrg>, OpsApiConstants {

    @Resource
    private OrgService orgService;

    @Override
    public AccessOrg findByIdentity(String identity, SignatureType signatureType, String path) {
        Org org = orgService.findByAccessKey(identity);
        if (org != null && org.isEnable()) {
            return new AccessOrg(org);
        }
        return null;
    }

}
