package com.qmth.ops.api.security;

public enum Permission {
    APP_VIEW("应用查看", null),
    APP_INSERT("应用新增", null),
    APP_EDIT("应用修改", null),
    MODULE_VIEW("模块查看", null),
    MODULE_INSERT("模块新增", null),
    MODULE_EDIT("模块修改", null),
    ENV_VIEW("环境查看", null),
    ENV_INSERT("环境新增", null),
    ENV_EDIT("环境修改", null),
    VERSION_VIEW("版本查看", null),
    VERSION_INSERT("版本新增", ScopeType.APP),
    VERSION_EDIT("版本修改", ScopeType.APP),
    PROPERTY_VIEW("程序配置查看", null),
    PROPERTY_BASELINE_EDIT("基线配置修改", ScopeType.APP),
    PROPERTY_EDIT("程序配置修改", ScopeType.ENV),
    NGINX_VIEW("Nginx配置查看", null),
    NGINX_BASELINE_EDIT("Nginx基线修改", ScopeType.APP),
    NGINX_EDIT("Nginx配置修改", ScopeType.ENV),
    DEPLOY_VIEW("部署查看", null),
    DEPLOY_INSERT("部署新增", null),
    DEPLOY_EDIT("部署修改", ScopeType.DEPLOY),
    DEPLOY_ORG_VIEW("部署绑定机构查看", ScopeType.DEPLOY),
    DEPLOY_ORG_EDIT("部署绑定机构修改", ScopeType.DEPLOY),
    DEPLOY_DEVICE_EDIT("部署绑定设备修改", ScopeType.DEPLOY),
    DEPLOY_SECRET_VIEW("部署密钥查看", ScopeType.DEPLOY),
    DEPLOY_LICENSE_ENTRY("部署授权管理", ScopeType.DEPLOY),
    DEPLOY_LICENSE_DOWNLOAD("部署授权下载", ScopeType.DEPLOY),
    ORG_VIEW("机构管理", null),
    ORG_INSERT("机构新增", null),
    ORG_EDIT("机构修改", null),
    WXAPP_VIEW("微信小程序管理", null),
    WXAPP_INSERT("微信小程序新增", null),
    WXAPP_EDIT("微信小程序修改", null),
    USER_VIEW("用户管理", null),
    USER_INSERT("用户新增", null),
    USER_EDIT("用户修改", null),
    OCR_SUPPLIER_VIEW("OCR服务商管理", null),
    OCR_SUPPLIER_INSERT("OCR服务商新增", null),
    OCR_SUPPLIER_EDIT("OCR服务商修改", null),
    LLM_SUPPLIER_VIEW("大模型服务商管理", null),
    LLM_SUPPLIER_INSERT("大模型服务商新增", null),
    LLM_SUPPLIER_EDIT("大模型服务商修改", null),
    LLM_MODEL_VIEW("大模型模型管理", null),
    LLM_MODEL_INSERT("大模型模型新增", null),
    LLM_MODEL_EDIT("大模型模型修改", null),
    LLM_ORG_CONFIG_VIEW("大模型机构配额管理", null),
    LLM_ORG_CONFIG_INSERT("大模型机构配额新增", null),
    LLM_ORG_CONFIG_EDIT("大模型机构配额修改", null);

    private String name;

    private ScopeType scope;

    Permission(String name, ScopeType scope) {
        this.name = name;
        this.scope = scope;
    }

    public String getCode() {
        return toString().toLowerCase();
    }

    public String getName() {
        return name;
    }

    public ScopeType getScope() {
        return scope;
    }
}
