package com.qmth.ops.api.vo;

import com.qmth.ops.biz.domain.App;
import com.qmth.ops.biz.domain.Version;
import com.qmth.ops.biz.service.VersionService;

public class AppVersionVO {

    private Long id;

    private String code;

    private String name;

    private Long latestVersionId;

    private String latestVersionName;

    private Long createTime;

    private Long updateTime;

    public AppVersionVO(App app, VersionService versionService) {
        this.id = app.getId();
        this.code = app.getCode();
        this.name = app.getName();
        this.createTime = app.getCreateTime();
        this.updateTime = app.getUpdateTime();

        Version version = versionService.findLatestByApp(app.getId());
        if (version != null) {
            latestVersionId = version.getId();
            latestVersionName = version.getName();
        }
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getLatestVersionId() {
        return latestVersionId;
    }

    public void setLatestVersionId(Long latestVersionId) {
        this.latestVersionId = latestVersionId;
    }

    public String getLatestVersionName() {
        return latestVersionName;
    }

    public void setLatestVersionName(String latestVersionName) {
        this.latestVersionName = latestVersionName;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public Long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Long updateTime) {
        this.updateTime = updateTime;
    }
}
