package com.qmth.ops.api.vo;

import com.qmth.boot.core.ai.model.llm.LlmAppType;
import com.qmth.ops.biz.domain.LlmModel;
import com.qmth.ops.biz.domain.LlmOrgConfig;
import com.qmth.ops.biz.domain.LlmPromptTemplate;
import com.qmth.ops.biz.domain.LlmSupplier;

public class LlmOrgConfigVO {

    private OrgVO org;

    private LlmModel model;

    private LlmSupplierVO supplier;

    private LlmAppType appType;

    private LlmPromptTemplate promptTemplate;

    private int permitCount;

    private int leftCount;

    public LlmOrgConfigVO(LlmSupplier supplier, LlmModel model, LlmPromptTemplate promptTemplate, OrgVO org,
            LlmOrgConfig llmOrgConfig) {
        this.org = org;
        this.model = model;
        this.promptTemplate = promptTemplate;
        this.supplier = new LlmSupplierVO(supplier);
        this.appType = llmOrgConfig.getAppType();
        this.permitCount = llmOrgConfig.getPermitCount();
        this.leftCount = llmOrgConfig.getLeftCount();
    }

    public OrgVO getOrg() {
        return org;
    }

    public void setOrg(OrgVO org) {
        this.org = org;
    }

    public LlmModel getModel() {
        return model;
    }

    public void setModel(LlmModel model) {
        this.model = model;
    }

    public LlmSupplierVO getSupplier() {
        return supplier;
    }

    public void setSupplier(LlmSupplierVO supplier) {
        this.supplier = supplier;
    }

    public LlmAppType getAppType() {
        return appType;
    }

    public void setAppType(LlmAppType appType) {
        this.appType = appType;
    }

    public LlmPromptTemplate getPromptTemplate() {
        return promptTemplate;
    }

    public void setPromptTemplate(LlmPromptTemplate promptTemplate) {
        this.promptTemplate = promptTemplate;
    }

    public int getPermitCount() {
        return permitCount;
    }

    public void setPermitCount(int permitCount) {
        this.permitCount = permitCount;
    }

    public int getLeftCount() {
        return leftCount;
    }

    public void setLeftCount(int leftCount) {
        this.leftCount = leftCount;
    }
}
