package com.qmth.ops.api.vo;

import com.qmth.boot.core.solar.enums.OrgSubType;
import com.qmth.boot.core.solar.enums.OrgType;

import java.util.Arrays;

public class OrgTypeVO extends CodeNameVO {

    private CodeNameVO[] subTypes;

    public OrgTypeVO(OrgType type) {
        super(type.toString(), type.getName());
        this.subTypes = Arrays.stream(OrgSubType.findByParent(type))
                .map(sub -> new CodeNameVO(sub.toString(), sub.getName())).toArray(CodeNameVO[]::new);
    }

    public CodeNameVO[] getSubTypes() {
        return subTypes;
    }

    public void setSubTypes(CodeNameVO[] subTypes) {
        this.subTypes = subTypes;
    }
}
