package com.qmth.ops.biz.ai.client.aliyun.llm;

import com.qmth.boot.core.ai.model.llm.ChatRequest;

import java.util.HashMap;
import java.util.Map;

public class AliyunChatRequest {

    private String model;

    private AliyunChatInput input;

    private Map<String, Object> parameters;

    public AliyunChatRequest(ChatRequest request, String model) {
        this.model = model;
        this.input = new AliyunChatInput();
        this.input.setMessages(request.getMessages());
        this.parameters = new HashMap<>();
        this.parameters.put("result_format", "message");
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public AliyunChatInput getInput() {
        return input;
    }

    public void setInput(AliyunChatInput input) {
        this.input = input;
    }

    public Map<String, Object> getParameters() {
        return parameters;
    }

    public void setParameters(Map<String, Object> parameters) {
        this.parameters = parameters;
    }
}
