package com.qmth.ops.biz.dao;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.qmth.boot.core.ai.model.llm.LlmAppType;
import com.qmth.ops.biz.domain.LlmOrgConfig;
import com.qmth.ops.biz.query.LlmOrgConfigQuery;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Update;

public interface LlmOrgConfigDao extends BaseMapper<LlmOrgConfig> {

    LlmOrgConfigQuery findByQuery(LlmOrgConfigQuery query);

    @Update("update llm_org_config set left_count=left_count+#{count}, permit_count=permit_count+#{count}"
            + " where org_id=#{orgId} and app_type=#{appType}")
    void permit(@Param("orgId") Long orgId, @Param("appType") LlmAppType appType, @Param("count") int count);

    @Update("update llm_org_config set left_count=left_count-1 where org_id=#{orgId} and app_type=#{appType} and left_count>0")
    void consume(@Param("orgId") Long orgId, @Param("appType") LlmAppType appType);
}
