package com.qmth.ops.biz.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.qmth.boot.core.solar.enums.OrgSubType;
import com.qmth.boot.core.solar.enums.OrgType;
import com.qmth.boot.core.solar.model.OrgInfo;
import com.qmth.ops.biz.utils.OrgSubTypeSetHandler;

import java.util.Set;

@TableName(value = "org", autoResultMap = true)
public class Org {

    @TableId(type = IdType.AUTO)
    private Long id;

    private String code;

    private String name;

    private OrgType type;

    @TableField(typeHandler = OrgSubTypeSetHandler.class)
    private Set<OrgSubType> subTypes;

    private String logo;

    private boolean enable;

    private String accessKey;

    private String accessSecret;

    private Long createTime;

    private Long updateTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public OrgType getType() {
        return type;
    }

    public void setType(OrgType type) {
        this.type = type;
    }

    public Set<OrgSubType> getSubTypes() {
        return subTypes;
    }

    public void setSubTypes(Set<OrgSubType> subTypes) {
        this.subTypes = subTypes;
    }

    public String getLogo() {
        return logo;
    }

    public void setLogo(String logo) {
        this.logo = logo;
    }

    public boolean isEnable() {
        return enable;
    }

    public void setEnable(boolean enable) {
        this.enable = enable;
    }

    public String getAccessKey() {
        return accessKey;
    }

    public void setAccessKey(String accessKey) {
        this.accessKey = accessKey;
    }

    public String getAccessSecret() {
        return accessSecret;
    }

    public void setAccessSecret(String accessSecret) {
        this.accessSecret = accessSecret;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public Long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Long updateTime) {
        this.updateTime = updateTime;
    }

    public OrgInfo buildOrgInfo(String server) {
        OrgInfo info = new OrgInfo();
        info.setId(getId());
        info.setCode(getCode());
        info.setName(getName());
        info.setLogo(logo != null ? server.concat(getLogo()) : null);
        info.setType(getType());
        info.setAccessKey(getAccessKey());
        info.setAccessSecret(getAccessSecret());
        return info;
    }
}
