package com.qmth.ops.biz.domain;

import java.util.List;

public class PropertyGroup {

    private String name;

    private String prefix;

    private List<PropertyGroupItem> available;

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPrefix() {
        return prefix;
    }

    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }

    public List<PropertyGroupItem> getAvailable() {
        return available;
    }

    public void setAvailable(List<PropertyGroupItem> available) {
        this.available = available;
    }

    public boolean accept(String key, String value) {
        if (key.startsWith(prefix)) {
            //有定义允许配置列表
            if (available != null && !available.isEmpty()) {
                for (PropertyGroupItem groupItem : available) {
                    if (groupItem.accept(key, value)) {
                        return true;
                    }
                }
                //不在允许配置列表内，不能保留
                return false;
            }
            //没有定义允许配置列表，直接保留
            else {
                return true;
            }
        }
        return false;
    }
}
