package com.qmth.ops.biz.domain;

import com.fasterxml.jackson.annotation.JsonIgnore;

public class PropertyGroupItem {

    public static final String KEY_PART_SPLIT = "\\.";

    public static final String FUZZT_REPLACE = "*";

    @JsonIgnore
    private String[] keyParts;

    private String key;

    private String description;

    private String type;

    private Object defaultValue;

    private Object[] options;

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
        this.keyParts = key.split(KEY_PART_SPLIT);
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Object getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(Object defaultValue) {
        this.defaultValue = defaultValue;
    }

    public Object[] getOptions() {
        return options;
    }

    public void setOptions(Object[] options) {
        this.options = options;
    }

    public boolean accept(String key, String value) {
        if (matchKey(key)) {
            //暂时不增加option校验
            /*
            if (options != null && options.length > 0) {
                return ArrayUtils.contains(options, value);
            } else {
                return true;
            }
            */
            return true;
        } else {
            return false;
        }
    }

    public boolean matchKey(String key) {
        String[] parts = key.split(KEY_PART_SPLIT);
        if (keyParts.length != parts.length) {
            return false;
        }
        for (int i = 0; i < keyParts.length; i++) {
            if (!keyParts[i].equals(FUZZT_REPLACE) && !keyParts[i].equals(parts[i])) {
                return false;
            }
        }
        return true;
    }

}
