package com.qmth.ops.biz.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class BranchName {

    private static final Pattern PATTERN = Pattern.compile("^[^0-9.]*(\\d+)\\.(\\d+)\\.(\\d+)$");

    private int main;

    private int middle;

    private int sub;

    public BranchName(String content) {
        Matcher m = PATTERN.matcher(content);
        if (m.find()) {
            setMain(Integer.parseInt(m.group(1)));
            setMiddle(Integer.parseInt(m.group(2)));
            setSub(Integer.parseInt(m.group(3)));
        } else {
            throw new IllegalArgumentException("分支名格式错误");
        }
    }

    public int getMain() {
        return main;
    }

    public void setMain(int main) {
        this.main = main;
    }

    public int getMiddle() {
        return middle;
    }

    public void setMiddle(int middle) {
        this.middle = middle;
    }

    public int getSub() {
        return sub;
    }

    public void setSub(int sub) {
        this.sub = sub;
    }

    public String toString() {
        return main + "." + middle + "." + sub;
    }

    public VersionNumber getVersionNumber() {
        return new VersionNumber(toString());
    }
}
