package com.qmth.ops.biz.utils;

import com.qmth.boot.core.solar.enums.OrgSubType;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.type.BaseTypeHandler;
import org.apache.ibatis.type.JdbcType;

import java.sql.CallableStatement;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashSet;
import java.util.Set;

public class OrgSubTypeSetHandler extends BaseTypeHandler<Set<OrgSubType>> {

    public static final String JOINER = ",";

    @Override
    public void setNonNullParameter(PreparedStatement preparedStatement, int i, Set<OrgSubType> orgTypes,
            JdbcType jdbcType) throws SQLException {
        preparedStatement.setString(i, toString(orgTypes));
    }

    @Override
    public Set<OrgSubType> getNullableResult(ResultSet resultSet, String s) throws SQLException {
        return toSet(resultSet.getString(s));
    }

    @Override
    public Set<OrgSubType> getNullableResult(ResultSet resultSet, int i) throws SQLException {
        return toSet(resultSet.getString(i));
    }

    @Override
    public Set<OrgSubType> getNullableResult(CallableStatement callableStatement, int i) throws SQLException {
        return toSet(callableStatement.getString(i));
    }

    private String toString(Set<OrgSubType> set) {
        return set != null ? StringUtils.join(set, JOINER) : StringUtils.EMPTY;
    }

    private Set<OrgSubType> toSet(String text) {
        Set<OrgSubType> set = new HashSet<>();
        String[] values = StringUtils.split(text, JOINER);
        if (values != null) {
            for (String value : values) {
                try {
                    set.add(OrgSubType.valueOf(value));
                } catch (Exception ignored) {
                }
            }
        }
        return set;
    }
}
