package com.qmth.ops.biz.utils;

import com.qmth.ops.biz.domain.PropertyItem;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;
import java.util.Set;

public class PropertyFileUtil {

    public static void write(List<PropertyItem> propertyList, OutputStream ous, String comment) throws IOException {
        Properties p = new SortedProperties();
        for (PropertyItem item : propertyList) {
            p.put(item.getKey(), item.getValue());
        }
        p.store(ous, comment);
    }

    public static List<PropertyItem> read(InputStream ins) throws IOException {
        Properties p = new Properties();
        p.load(ins);
        Set<String> keys = p.stringPropertyNames();
        List<PropertyItem> list = new LinkedList<>();
        for (String key : keys) {
            PropertyItem item = new PropertyItem();
            item.setKey(key);
            item.setValue(p.getProperty(key));
            list.add(item);
        }
        return list;
    }
}