package com.qmth.ops.biz.utils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class VersionNumber {

    private static final Pattern PATTERN = Pattern.compile("^(\\d+)\\.(\\d+)\\.(\\d+)$");

    private int main;

    private int middle;

    private int sub;

    public VersionNumber(String content) {
        Matcher m = PATTERN.matcher(content);
        if (m.find()) {
            main = Integer.parseInt(m.group(1));
            middle = Integer.parseInt(m.group(2));
            sub = Integer.parseInt(m.group(3));
        } else {
            throw new IllegalArgumentException("版本号格式错误");
        }
    }

    public int getMain() {
        return main;
    }

    public void setMain(int main) {
        this.main = main;
    }

    public int getMiddle() {
        return middle;
    }

    public void setMiddle(int middle) {
        this.middle = middle;
    }

    public int getSub() {
        return sub;
    }

    public void setSub(int sub) {
        this.sub = sub;
    }

    public String toString() {
        return main + "." + middle + "." + sub;
    }

}
