package com.qmth.ops.biz.wxapp.api;

import com.qmth.boot.core.retrofit.annotatioin.RetrofitClient;
import com.qmth.ops.biz.wxapp.dto.AccessTokenResult;
import com.qmth.ops.biz.wxapp.dto.Code2SessionResult;
import com.qmth.ops.biz.wxapp.dto.GetPhoneNumberRequest;
import com.qmth.ops.biz.wxapp.dto.GetPhoneNumberResult;
import retrofit2.http.Body;
import retrofit2.http.GET;
import retrofit2.http.POST;
import retrofit2.http.Query;

@RetrofitClient(baseUrl = "https://api.weixin.qq.com/")
public interface WxappApiClient {

    @GET("cgi-bin/token")
    AccessTokenResult getAccessToken(@Query("appid") String appId, @Query("secret") String secret,
            @Query("grant_type") String grantType);

    @GET("sns/jscode2session")
    Code2SessionResult code2session(@Query("appid") String appId, @Query("secret") String secret,
            @Query("js_code") String code, @Query("grant_type") String grantType);

    @POST("wxa/business/getuserphonenumber")
    GetPhoneNumberResult getPhoneNumber(@Query("access_token") String accessToken, @Body GetPhoneNumberRequest body);
}
