package com.qmth.ops.biz.wxapp.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.qmth.boot.core.solar.model.WxappAccessToken;

public class AccessTokenResult implements BaseResult {

    @JsonProperty("access_token")
    private String accessToken;

    @JsonProperty("expires_in")
    private Long expireSecond;

    @JsonProperty("errcode")
    private Long errorCode;

    @JsonProperty("errmsg")
    private String errorMessage;

    public String getAccessToken() {
        return accessToken;
    }

    public void setAccessToken(String accessToken) {
        this.accessToken = accessToken;
    }

    public Long getExpireSecond() {
        return expireSecond;
    }

    public void setExpireSecond(Long expireSecond) {
        this.expireSecond = expireSecond;
    }

    @Override
    public Long getErrorCode() {
        return errorCode;
    }

    @Override
    public void setErrorCode(Long errorCode) {
        this.errorCode = errorCode;
    }

    @Override
    public String getErrorMessage() {
        return errorMessage;
    }

    @Override
    public void setErrorMessage(String errorMessage) {
        this.errorMessage = errorMessage;
    }

    public WxappAccessToken output() {
        WxappAccessToken result = new WxappAccessToken();
        result.setAccessToken(accessToken);
        result.setExpireTime(System.currentTimeMillis() + expireSecond * 1000);
        return result;
    }
}
