package com.qmth.ops.biz.wxapp.dto;

import com.qmth.boot.core.exception.StatusException;
import org.apache.commons.lang3.StringUtils;

public interface BaseResult {

    Long getErrorCode();

    void setErrorCode(Long errorCode);

    String getErrorMessage();

    void setErrorMessage(String errorMessage);

    default boolean success() {
        return getErrorCode() == null || getErrorCode() == 0;
    }

    default StatusException exception() {
        return new StatusException(201, "wxapp api error",
                getErrorCode() + ":" + StringUtils.trimToEmpty(getErrorMessage()), null);
    }
}
